# Admin and Site Enhancements (ASE)

Contributors: qriouslad  
Donate link: https://bowo.io/asenha-sp-rdm  
Tags: enhancements, tweaks, optimizations, tools  
Requires at least: 4.6  
Tested up to: 6.3  
Stable tag: 5.4.0.1  
Requires PHP: 5.6  
License: GPLv2 or later  
License URI: http://www.gnu.org/licenses/gpl-2.0.html

![](.wordpress-org/banner-772x250.png)

Duplicate post, post order, image resize, email via SMTP, admin menu editor, custom css / code, disable gutenberg and much more in a single plugin.

## Description

Admin and Site Enhancements (ASE) helps you to **easily enhance** various admin workflows and site aspects while **replacing multiple plugins** doing it. 

Here's a review at v5.2.9 by Alexis FH of WP Made Simple.

https://www.youtube.com/watch?v=DPBEx1vHwuY

Here's a review at v5.1.0 by Paul Charlton of WPTuts.

[youtube https://youtu.be/V-_4TnjGloE]

Here's a review at v5.0.2 by Imran Siddiq @websquadron.

https://youtu.be/Ja8GxOPGqKY

Here's a quick review at v5.0.1 by Nathan Wrigley @wpbuilds.

https://www.youtube.com/watch?v=QwaWL6znuZg&t=3242s

Here's a walkthrough of the plugin at v4.8.2 by Nathan Ingram.

https://www.youtube.com/watch?v=_qXGDEBfMp0&t=2984s

### What Users Say

_"**Every single thing works as expected**."_ ~[Nathan Wrigley @wpbuilds](https://www.youtube.com/watch?v=QwaWL6znuZg&t=3242s)

_"**I’m replacing so many plugins with this!**"_ ~[@instadesign](https://wordpress.org/support/topic/im-replacing-so-many-plugins-with-this/)

_"**So many useful features** it blows my mind, as well as enabling me to **ditch so many other plugins!**"_ ~[@simonclay](https://wordpress.org/support/topic/amazing-plugin-2441/)

_"**A must have plugin for most sites**. So many useful features. along with a great developer who is open to suggestions."_ ~[@akgt](https://wordpress.org/support/topic/amazing-plugin-2443/)

_"This plugin is simply amazing. It **easily replaces a dozen or more plugins I install on every website project**. It is **super lightweight**, easy to use, and support has been wonderful and responsive. Highly recommended!"_ ~[NetzzJD](https://wordpress.org/support/topic/amazing-must-have-plugin-2/)

_"**...it replaces many single purpose plugins which bloat up the site and the admin area**."_ ~[@tageins](https://wordpress.org/support/topic/replaces-a-lot-of-single-purpose-plugins/)

_"**Full of useful features, works without problems**."_ ~[Krzysztof Płaneta](https://wordpress.org/support/topic/full-of-useful-features-works-without-problems/)

_"**Great plugin! Clear, useful, and a joy to use**."_ ~[Todd](https://wordpress.org/support/topic/great-plugin-clear-useful-and-a-joy-to-use/)

_"One of those plugins that feels like it **should be part of the [WordPress] core, lots of useful features without the bloat**."_ ~[@mohobook](https://wordpress.org/support/topic/great-contribution-5/)

_"It is great how many small things are all included in this one plugin. **Definitely makes things feel a lot simpler**."_ ~[@kenmundell
](https://wordpress.org/support/topic/great-multi-purpose-plugin/)

_"**This plugin is what I have been waiting for to see for years!**"_ ~[@AlexGraphicD](https://wordpress.org/support/topic/amazing-swiss-army-tool-for-wordpress/)

_"Great job! **Saved me lots of time to add lots of plugins** to get ready for my work. It's a relief to have **everything streamlined and ready to go**."_ ~[Tao Sheng](https://wordpress.org/support/topic/super-2817/)

_"I’m already in love with this plugin... **It will make my WP-life a lot easier**."_ ~[@medieskolen](https://wordpress.org/support/topic/im-allready-in-love-with-this-plugin/)

_"I really love how this plugin incorporates **so many small fixes or tweaks** that are needed with WordPress - I can now get rid of many other plugins."_ ~[Dale Reardon](https://wordpress.org/support/topic/fantastic-plugin-replacing-many-other-plugins/)

_"This plugin allows you to install and maintain **one plugin instead of a host of smaller ones**. My tests were all successful and I was happy to simplify my maintenance with fewer plugins."_ ~[Vic Drover](https://wordpress.org/support/topic/replaced-4-plugins-worked-well-a/)

_"With this plugin, I can remove tons of plugins to **reduce the possibility of plugin conflicts**."_ ~[@chiehliniceday](https://wordpress.org/support/topic/very-powerful-tool-13/)

_"**It’s worth 10 stars (or more)**. This plugin eliminates the need to install many other plugins and also **makes functions.php smaller** since I have to insert fewer code snippets."_ ~[Angelika Reisiger](https://wordpress.org/support/topic/its-worth-10-stars-or-more/)

_"Excellent and **very well-supported plugin**; saves me a lot of work! Admin Site Enhancements has made my list of 'must install' plug-ins, since **it makes so many other tasks much easier**."_ ~[@grizdev](https://wordpress.org/support/topic/excellent-and-very-well-supported-plugin-saves-me-a-lot-of-work/)

_"**I was super skeptical** that this plugin could do so much without any problems, **but I was wrong... 100% recommended!**"_ ~[@scarlywebs](https://wordpress.org/support/topic/the-all-in-one-plugin-you-need-in-your-arsenal/)

_"Normally, I tend to steer clear of “all-in-one” plugins; however, I believe that the **selection of tools** incorporated into this plugin has been astutely deliberated, given that it **nearly aligns entirely with the options I typically apply to each website**."_ ~[@cvladan](https://wordpress.org/support/topic/excellent-features-selection/)

_"There are so many little **wordpress tweaks** that we all have to do which either requires **a bunch of small plugins or added code snippets**. This is a great step in **consolidating them into a well organized spot, without polluting the admin screen with nags and menu items and other junk**."_ ~[Todd](https://wordpress.org/support/topic/great-plugin-clear-useful-and-a-joy-to-use/)

_"**ASE has been a game-changer for us**... we were able to remove numerous duplicate plugins, reducing clutter and improving efficiency. ASE's enhanced admin dashboard, improved site performance, and robust security features have truly transformed our website management... It's a must-have plugin for anyone looking to optimize their WordPress site and streamline their workflow."_ ~[@tomhung](https://wordpress.org/support/topic/this-has-reduced-my-plugin-list-by-6-7/)

_"I love the **modular approach**. And I love that the whole plugin - with all its potential functionality - is **smaller in file-size than some of the plugins that it replaces**, which do only one of these things. Thank you for the great work!"_ ~[Dave](https://wordpress.org/support/topic/very-useful-swiss-army-knife/)

_"Thank You for **killing the dashboard SPAM!**"_ ~[@happyfrank73](https://wordpress.org/support/topic/this-is-what-freedom-tastes-like/)

_"Great compilation of settings and options. **It had quickly become one of my essential plugins**."_ ~[@unapersona](https://wordpress.org/support/topic/very-useful-3276/)

_"**Incredibly powerful and well organized**. It’s a real accomplishment to put this many features into a plugin and still make it easy to navigate."_ ~[Nathan Ingram](https://wordpress.org/support/topic/holy-cow-this-is-excellent/)

_"\[This\] is a Swiss Army Knife in terms of features that will **keep your WordPress clean and optimal**."_ ~[@samirhp](https://wordpress.org/support/topic/there-are-no-words-just-amazing/)

_"**Has noticeably improved performance on many of my sites**."_ ~[@instadesign](https://wordpress.org/support/topic/im-replacing-so-many-plugins-with-this/)

_"**...everything is clear, fast, consistent and lightweight**."_ ~[Peter](https://wordpress.org/support/topic/amazing-job-premium-functions-in-free-plugin/)

_"**Greatest plugin ever**."_ ~[@angelaustr](https://wordpress.org/support/topic/greatest-plugin-ever-11/)

_"**p.s. There are bugs**. This is software development after all and **I'm the developer (as well as user)**. [Please report](https://wordpress.org/support/plugin/admin-site-enhancements/) if you found one, and **I'll try to fix the next chance I get**. Thanks!"_ ~[Bowo](https://bowo.io/bowoio-asenha)


### Content Management

* **Content Duplication**. Enable one-click duplication / clone / copy of pages, posts and custom posts. The corresponding taxonomy terms and post meta will also be duplicated.
* **Content Order**. Enable custom order for pages, posts and custom post types. Useful for displaying them in the desired order in wp-admin and on the frontend. e.g. projects, services, FAQs, team members, testimonials, etc.
* **Media Replacement**. Easily replace any type of media file with a new one while retaining the existing media ID, publish date and file name. So, no existing links will break.
* **SVG Upload**. Allow some or all user roles to upload SVG files, which will then be sanitized to keep things secure.
* **External Permalinks**. Enable pages, posts and/or custom post types to have permalinks that point to external URLs. The rel="noopener noreferrer nofollow" attribute will also be added for enhanced security and SEO benefits. Compatible with links added using [Page Links To](https://wordpress.org/plugins/page-links-to/).
* **Open All External Links in New Tab**. Force all links to external sites to open in new browser tab via target="\_blank" attribute. The rel="noopener noreferrer nofollow" attribute will also be added for enhanced security and SEO benefits.
* **Allow Custom Navigation Menu Items to Open in New Tab**. Allow custom navigation menu items to have links that open in new browser tab via target="\_blank" attribute. The rel="noopener noreferrer nofollow" attribute will also be added for enhanced security and SEO benefits.
* **Auto-Publish Posts with Missed Schedule**. Trigger publishing of scheduled posts of all types marked with "missed schedule", anytime the site is visited.
* **Enhance List Tables**. Improve the usefulness of listing pages of various post types by adding / removing columns and elements.
  * _Show the featured image column_: in the list tables for pages and post types that support featured images.
  * _Show the excerpt column_: in the list tables for pages and post types that support excerpt.
  * _Show the ID as a column or in the action rows_: in the list tables for pages, all post types, all taxonomies, media, users and comments.
  * _Show custom taxonomy dropdown filter(s)_: on the list tables of all post types for taxonomies that are hierarchical like post categories.
  * _Remove the comments column_: in in the list tables for pages, post types that support comments, and also media/attachments.
  * _Remove the post tags column_: in the list table for posts.

### Admin Interface

* **Hide Admin Notices**. Clean up admin pages by moving notices into a separate panel easily accessible via the admin bar.
* **Wider Admin Menu**. Give the admin menu more room to better accommodate wider items.
* **Admin Menu Editor / Organizer**. Customize the order of the admin menu and optionally change menu item title or hide some items.
* **Disable Dashboard Widgets**. Clean up and speed up the dashboard by completely disabling some or all widgets. Disabled widgets won't load any assets nor show up under Screen Options.
* **Clean Up Admin Bar**. Remove various elements from the admin bar.
  * Remove WordPress logo/menu
  * Remove customize menu/link
  * Remove updates counter/link
  * Remove comments counter/link
  * Remove new content menu
  * Remove 'Howdy' text
  * Remove the Help tab and drawer
* **Hide Admin Bar**. Hide it on the front end for all or some user roles.

### Log In / Log Out

* **Change Login URL**. Improve site security by using a custom login URL, e.g. www.example.com/backend
* **Log In/Out Menu**. Enable log in, log out and dynamic log in/out menu item for addition to any menu.
* **Last Login Column**. Log when users on the site last logged in and display the date and time in the users list table.
* **Redirect After Login / Logout**. Set custom redirect URL for all or some user roles after login / logout.

### Custom Code

* **Custom Admin CSS**. Add custom CSS on all admin pages for all user roles.
* **Custom Frontend CSS**. Add custom CSS on all frontend pages for all user roles.
* **Insert &lt;head&gt;, &lt;body&gt; and &lt;footer&gt; Code**. Easily insert &lt;meta&gt;, &lt;link&gt;, &lt;script&gt; and &lt;style&gt; tags, Google Analytics, Tag Manager, AdSense, Ads Conversion and Optimize code, Facebook, TikTok and Twitter pixels, etc.
* **Custom Body Class**. Add custom &lt;body&gt; class(es) on the singular view of some or all public post types. Compatible with classes already added using [Custom Body Class plugin](https://wordpress.org/plugins/wp-custom-body-class).
* **Manage ads.txt and app-ads.txt**. Easily edit and validate your ads.txt and app-ads.txt content.
* **Manage robots.txt**. Easily edit and validate your robots.txt content.

### Disable Components

* **Disable Gutenberg**. Disable the Gutenberg block editor for some or all applicable post types. Optionally disable frontend block styles / CSS files for the selected post types.
* **Disable Block-Based Widgets Settings Screen**. Restores the classic widgets settings screen when using a classic (non-block) theme.
* **Disable Comments**. Disable comments for some or all public post types. When disabled, existing comments will also be hidden on the frontend.
* **Disable REST API**. Disable REST API access for non-authenticated users and remove URL traces from &lt;head&gt;, HTTP headers and WP RSD endpoint.
* **Disable Feeds**. Disable all RSS, Atom and RDF feeds. This includes feeds for posts, categories, tags, comments, authors and search. Also removes traces of feed URLs from &lt;head&gt;.
* **Disable All Updates**. Completely disable core, theme and plugin updates and auto-updates. Will also disable update checks, notices and emails.
* **Disable Smaller Components**. Prevent smaller components from running or loading. Make the site more secure, load slightly faster and be more optimized for crawling by search engines.
  * Disable the **generator &lt;meta&gt; tag** in &lt;head&gt;, which discloses the WordPress version number. Older versions(s) might contain unpatched security loophole(s).
  * Disable the **Windows Live Writer (WLW) manifest &lt;link&gt; tag** in &lt;head&gt;. The WLW app was discontinued in 2017.
  * Disable the **Really Simple Discovery (RSD) &lt;link&gt; tag** in &lt;head&gt;. It's not needed if your site is not using pingback or remote (XML-RPC) client to manage posts.
  * Disable the default **WordPress shortlink &lt;link&gt; tag** in &lt;head&gt;. Ignored by search engines and has minimal practical use case. Usually, a dedicated shortlink plugin or service is preferred that allows for nice names in the short links and tracking of clicks when sharing the link on social media.
  * Disable loading of **dashicons CSS and JS files** on the front-end for public site visitors.
  * Disable **emoji support for pages, posts and custom post types** on the admin and frontend. The support is primarily useful for older browsers that do not have native support for it. Most modern browsers across different OSes and devices now have native support for it.

### Security

* **Limit Login Attempts**. Prevent brute force attacks by limiting the number of failed login attempts allowed per IP address.
* **Obfuscate Author Slugs**. Obfuscate publicly exposed author page URLs that shows the user slugs / usernames, e.g. _sitename.com/author/username1/_ into _sitename.com/author/a6r5b8ytu9gp34bv/_, and output 404 errors for the original URLs. Also obfuscates in _/wp-json/wp/v2/users/_ REST API endpoint.
* **Disable XML-RPC**. Protect your site from brute force, DOS and DDOS attacks via XML-RPC. Also disables trackbacks and pingbacks.

### Optimizations

* **Image Upload Control**. Resize newly uploaded, large images to a smaller dimension and delete originally uploaded files. BMPs and non-transparent PNGs will be converted to JPGs and resized.
* **Revisions Control**. Prevent bloating the database by limiting the number of revisions to keep for some or all post types supporting revisions.
* **Heartbeat Control**. Modify the interval of the WordPress heartbeat API or disable it on admin pages, post creation/edit screens and/or the frontend. This will help reduce CPU load on the server.

### Utilities

* **Email Delivery**. Set custom sender name and email. Optionally use external SMTP service to ensure notification and transactional emails from your site are being delivered to inboxes. Send a test email to check if configuration works as intended.
* **Multiple User Roles**. Enable assignment of multiple roles during user account creation and editing. This maybe useful for working with roles not defined in WordPress core, e.g. from e-commerce or LMS plugins.
* **View Admin as Role**. View admin pages and the site (logged-in) as one of the non-administrator user roles.
* **Password Protection**. Password-protect the entire site to hide the content from public view and search engine bots / crawlers. Logged-in administrators can still access the site as usual.
* **Maintenance Mode**. Show a customizable maintenance page on the frontend while performing a brief maintenance to your site. Logged-in administrators can still view the site as usual.
* **Redirect 404 to Homepage**. Perform 301 (permanent) redirect to the homepage for all 404 (not found) pages.

Admin and Site Enhancements (ASE) will include more enhancements, tweaks and useful features in future versions. Please [give feedback](https://bowo.io/feedback-asenha) on must-have plugins or code snippets you enable on sites that you manage, and the functionalities will be considered for inclusion as well.

### Give Back

* [**A nice review**](https://bowo.io/asenha-rvw-dsc) would be great!
* [**Give feedback**](https://bowo.io/asenha-fdbk-dsc) and help improve future versions.
* [**Help translate**](https://bowo.io/asenha-trnslt-dsc) plugin description on this page into your language.
* [**Github repo**](https://bowo.io/asenha-gthb-dsc) to contribute code.
* **Sponsor my work** with as little as USD 1, [**monthly**](https://bowo.io/asenha-sp-gth-rdm) or [**one-time**](https://bowo.io/asenha-sp-ppl-rdm).

### Check These Out Too

* [System Dashboard](https://wordpress.org/plugins/system-dashboard/): Central dashboard to monitor various WordPress components, processes and data, including the server.
* [Debug Log Manager](https://wordpress.org/plugins/debug-log-manager/): Log PHP, database and JavaScript errors via WP_DEBUG with one click. Conveniently create, view, filter and clear the debug.log file.
* [Variable Inspector](https://wordpress.org/plugins/variable-inspector/): Inspect PHP variables on a central dashboard in wp-admin for convenient debugging.
* [Code Explorer](https://wordpress.org/plugins/code-explorer/): Fast directory explorer and file/code viewer with syntax highlighting.
* [Flexible Scroll Top](https://wordpress.org/plugins/flexible-scroll-top/) and [Floating Share Buttons](https://wordpress.org/plugins/floating-share-button/) is a lightweight combo with minimalist UI.
* [WordPress Newsboard](https://bowo.io/asenha-wpn-dsc): The latest news, articles, podcasts and videos from 100+ WordPress-focused sources.

## Screenshots

1. Content Management
   ![Content Management](.wordpress-org/screenshot-1.png)
2. Admin Interface
   ![Admin Interface](.wordpress-org/screenshot-2.png)
3. Log In | Log Out
   ![Log In | Log Out](.wordpress-org/screenshot-3.png)
4. Custom Code
   ![Custom Code](.wordpress-org/screenshot-4.png)
5. Disable Components
   ![Disable Components](.wordpress-org/screenshot-5.png)
6. Security
   ![Security](.wordpress-org/screenshot-6.png)
7. Optimizations
   ![Optimizations](.wordpress-org/screenshot-7.png)
8. Utilities
   ![Utilities](.wordpress-org/screenshot-8.png)

## Frequently Asked Questions

### Why build this plugin?

Hoping that this is useful in reducing the number of plugins we install the first time we set up a site.

## Changelog

**Admin and Site Enhancements (ASE) v1.0.0** was released on October 17, 2022. Since then, there have been **54 _point_ releases** (e.g. 1.1.0 ) and **42 _patch_ releases** (e.g. 4.9.1). 

Each **_point_** release usually corresponds with the addition of one new module/feature. Each module/feature usually is the equivalent of one (or more) single-purpose plugin. Each **_patch_** release usually contain one or more bugfix or improvement to existing modules/features.

> _"**Reported a bug yesterday, it was fixed today**. Can't ask for better than that.."_ ~[Greg Mount](https://wordpress.org/support/topic/very-handy-plugin-by-a-great-dev/)

> _"Simply the best! Still looking for the sixth star for you. **Don’t stop developing... We are supporting you!**"_ ~[@springbreak](https://wordpress.org/support/topic/too-good-to-be-true-22/)


#### Kindly Consider Sponsoring Ongoing Development and Maintenance

If this plugin has been useful for your **personal project(s), paid dev work, client site(s) and or agency's workflow**, please kindly consider **sponsoring from as little as USD 1** ([**monthly**](https://bowo.io/asenha-sp-gth-chnlg) or [**one-time**](https://bowo.io/asenha-sp-ppl-chnlg)).

This helps ensure you're going to continue seeing **new features and/or fixes**, hopefully **for years to come**. Thank you!

> _"**Amazing job – premium functions in free plugin**."_ ~[Peter](https://wordpress.org/support/topic/amazing-job-premium-functions-in-free-plugin/)

> _"**I will definitely support it’s development** because I know it will **save me time and frustration on all of the websites I set up**."_ ~[Todd](https://wordpress.org/support/topic/great-plugin-clear-useful-and-a-joy-to-use/)

> _"A very very useful plugin. **I have made a little sponsorship and encourage other users to do the same as it is so much deserved**. Thank you Bowo!"_ ~[@pgrand83](https://wordpress.org/support/topic/very-very-useful-54/)

**More than 250 hours of dev time** have been spent on developing and mantaining this plugin. At v5.4.0 (released on July 25, 2023) and **7,000+ active installs**, there have been [**4 monthly sponsors**](https://bowo.io/asenha-sp-gth-chnlg) and [**30 one-time sponsors**](https://bowo.io/asenha-sp-ppl-chnlg). You can be one today!

**USD 1** [**monthly**](https://bowo.io/asenha-sp-gth-chnlg) or [**one-time**](https://bowo.io/asenha-sp-ppl-chnlg) is all it takes for you to start sponsoring ASE. Thank you!

### 5.4.0 (2023.07.25)

* **[ADDED] Content Management >> Allow Custom Navigation Menu Items to Open in New Tab**. Allow custom navigation menu items to have links that open in new browser tab via target="\_blank" attribute. The rel="noopener noreferrer nofollow" attribute will also be added for enhanced security and SEO benefits. Props to [@tomhung](https://github.com/tomhung) for [suggesting this feature](https://github.com/qriouslad/admin-site-enhancements/issues/4) and providing the [code snippet](https://gitlab.com/-/snippets/2567854) to base it upon.

* Checked compatibility with WordPress v6.3 RC1

### 5.3.2 (2023.07.15)

* **[FIXED] Disable Smaller Components >> Disable the generator meta tag:** fixed PHP fatal error in some scenarios for PHP v8.0+. Props to [@swissspidy](https://github.com/swissspidy) for [reporting it](https://github.com/qriouslad/admin-site-enhancements/issues/4) on Github.

* **[IMPROVED] Content Management >> External Permalinks:** removed jQuery dependency on the front-end in public.js. Replaced script with pure JS version churn out by ChatGPT which was prompted by Marco M.J. So, yes... first AI usage in ASE code. Pretty cool. 🙂

### 5.3.1 (2023.07.14)

* **[FIXED] Admin Interface >> Disable Dashboard Widgets:** fixed PHP warning. Props to [@mohobook](https://wordpress.org/support/users/mohobook/) for [reporting it](https://wordpress.org/support/topic/code-error-media-replacement-not-working/).

* **[IMPROVED] Content Management >> Open All External Links in New Tab:** will now exclude relative URLs which points to internal URLs from being opened in a new tab. Props to [@francismacomber](https://wordpress.org/support/users/francismacomber/) for [reporting it](https://wordpress.org/support/topic/open-all-external-links-in-new-tab-misidentifies-relative-urls-as-external/).

### 5.3.0 (2023.07.08)

* **[IMPROVED] Utilities >> Email Delivery**: You can now send a test email to verify if your custom sender name/email and SMTP configuration work as intended. Props to many users for suggesting this in the support forum [here](https://wordpress.org/support/topic/request-test-email-delivery/), [here](https://wordpress.org/support/topic/test-smtp-email-delivery/), [here](https://wordpress.org/support/topic/smtp-email-delivery/), [here](https://wordpress.org/support/topic/check-smtp-by-sending-an-email/) and [here](https://wordpress.org/support/topic/please-add-a-test-option-for-smtp/).

### 5.2.11 (2023.07.05)

* **[IMPROVED] Utilities >> Password Protection** This will now also work on non-HTTPS sites. Props to Sascha for reporting the issue via the contact form at [bowo.io](https://bowo.io) and providing great detail about what was done to try and troubleshoot it, and later on found the root cause of the issue, which made fixing the issue much simpler.

### 5.2.10 (2023.06.30)

* **[IMPROVED] Utilities >> Email Delivery** Custom sender name / email can now be set and enforced independent of delivery via external SMTP service/account. Props to [@lcwilson18](https://wordpress.org/support/users/lcwilson18/) for [suggesting it](https://wordpress.org/support/topic/smtp-email-delivery/).

### 5.2.9 (2023.06.27)

* **[FIXED] Log In | Log Out >> Redirect After Login** will now correctly redirect to an internal wp-admin page, e.g. wp-admin/edit.php?post_type=page (View All Pages). Props to [@tomhung](https://wordpress.org/support/users/tomhung/) for [reporting it](https://wordpress.org/support/topic/redirect-after-login-wont-redirect-to-internal-page/).

### 5.2.8 (2023.06.26)

* **[IMPROVED] Front-end public.js** will only be loaded if relevant modules that use it are enabled. Props to Martin M. for reporting the issue via the contact form at [bowo.io](https://bowo.io) and Maxime D. via Facebook message.

### 5.2.7 (2023.06.26)

* **[FIXED] Custom Code**: Possible fix for CodeMirror (code editor) JS error caused by jQuery not being explicitly set as a dependency. When this happens, ASE's admin page is rendered blank / useless. Props to [@sarah-haruel](https://wordpress.org/support/users/sarah-haruel/) for [reporting it](https://wordpress.org/support/topic/admin-and-site-enhancements-ase-disabled-when-slideshow-se-activated/).
* **[IMPROVED] Log In | Log Out >> Change Login URL**: Improve module description to avoid confusion with renaming the entire /wp-admin/ as opposed to renaming just the login URL. Props to [Maz Ziebell](https://wordpress.org/support/users/max-ziebell/) for the suggestion.
* **[FIXED] Disable Components >> Disable Gutenberg**: Fixed PHP warning when saving a CPT post where gutenberg has been disabled. Props to [@gregmount](https://wordpress.org/support/users/gregmount/) for [reporting it](https://wordpress.org/support/topic/disable-gutenberg-throws-php-warning/).
* **[ADDED] A dismissible Sponsorship / Rating / Feedback nudge/notice** has been added to ASE's admin page (only), which will appear after every 10 consecutive clicks of the "Save changes" button. This is a way to try and gain additional support for ASE's ongoing development and maintenance. I hope you don't mind. 🙂

### 5.2.6 (2023.06.24)

* **[FIXED] Security >> Limit Login Attempts**: Fixed PHP warning issue. Props to [@tomo55555](https://wordpress.org/support/users/tomo55555/) for [reporting it](https://wordpress.org/support/topic/warning-error-reported/).

### 5.2.5 (2023.06.22)

* **[FIXED] Utilities >> Password Protection**: Fixed the issue that causes the password protection form/page to have no styling after v5.2.4 patch release. Props to [@gregmount](https://wordpress.org/support/users/gregmount/) for [reporting it](https://wordpress.org/support/topic/v5-2-4-breaks-styling-on-password-protection/).

### 5.2.4 (2023.06.21)

* **[FIXED] Disable Components >> Disable Dashicons**: Fixed PHP warning when executing WP CLI commands. Props to [@tomhung](https://wordpress.org/support/users/tomhung/) for [reporting it](https://wordpress.org/support/topic/php-warning-strpos-empty-needle-2/).

* **[RESOLVED] Unable to Save Changes in ASE**: This is caused by plugin conflict which happens when [WP STAGING - Backup Duplicator & Migration](https://wordpress.org/plugins/wp-staging/) is active. Props to [@kilimats](https://wordpress.org/support/users/kilimats/) for [reporting it](https://wordpress.org/support/topic/doesnt-save-14/) and to [@allbutone](https://wordpress.org/support/users/allbutone/) for liasing with the developer of WP Staging to [fix things on their end](https://wordpress.org/support/topic/plugin-conflict-prevents-saving/).

### 5.2.3 (2023.06.18)

* **[FIXED] Optimizations >> Image Upload Control**: fixed a small code error that prevented image resizing from actually happening. Props to [@matija80](https://wordpress.org/support/users/matija80/) for [reporting it](https://wordpress.org/support/topic/image-upload-control-resizing-doesnt-work/).

* **[FIXED] Admin Interface >> Disable Dashboard Widgets**: fixed "array offset on value of type bool" error. Props to [@grizdev](https://wordpress.org/support/users/grizdev/) for [reporting it](https://wordpress.org/support/topic/disable-dashboard-widgets-produces-array-offset-on-value-of-type-bool-error/).

* **[FIXED] Admin Interface >> Wider Admin Menu**: fixed an issue where wider admin menu pushed WooCommerce page header content to shift right and be cut-off from the screen. Props to [@malaga16](https://wordpress.org/support/users/malaga16/) for [reporting it](https://wordpress.org/support/topic/admin-menu-sidebar-custom-with-problem/).

* **[FIXED] Utilities >> Password Protection**: fixed PHP Warning. Props to [@gregmount](https://wordpress.org/support/users/gregmount/) for [reporting it](https://wordpress.org/support/topic/php-warning-on-password-protected-login/).

### 5.2.2 (2023.06.14)

* **[FIXED] Security >> Limit Login Attempts**: fixed redirection loop that happens when custom login URL is enabled and user has reached the allowed failed login attempts count. Props to [@allbutone](https://wordpress.org/support/users/allbutone/) for [reporting it](https://wordpress.org/support/topic/error-limit-login-attempts/) and narrowing down the steps to replicate the issue reliably, which helps with troubleshooting.

### 5.2.1 (2023.06.13)

* **[FIXED] Disable Components >> Disable Comments**: Fixed an issue where a JS alert saying "Are you sure you want to do this? The comment changes you made will be lost." popups when trying to update a page / post / post type where commenting has been disabled. Props to [@dagaloni](https://wordpress.org/support/users/dagaloni/) for [thoroughly reporting it](https://wordpress.org/support/topic/are-you-sure-you-want-to-to-this-popup-for-updateting-page/) with screenshots and steps to replicate the issue.

* **[FIXED] Utilities >> View Admin as Role**: Provide a simple and secure method to regain administrator access when something goes wrong while switching to non-administrator role. This occasionally happens when the login session ended and you're being logged out by the system. Instruction on how to regain administrator access has been added to the settings section for the module. Props to [@cebuss](https://wordpress.org/support/users/cebuss/) for [thoroughly reporting it](https://wordpress.org/support/topic/feature-request-avoid-locking-people-out-of-their-site/) and providing a way to regain access via direct changes to the database.

* **[SECURITY] Utilities >> View Admin as Role**: Make sure only users performing role switching can access the role switcher admin bar menu. This ensures that non-administrator users logging in normally won't see the menu and prevent them from performing role switching.

### 5.2.0 (2023.06.10)

* **[ADDED] Admin Interface >> Wider Admin Menu**. Give the admin menu more room to better accommodate wider items. Props to [@dvaer](https://profiles.wordpress.org/dvaer/) and [@kilimats](https://wordpress.org/support/users/kilimats/) for [suggesting this](https://wordpress.org/support/topic/feature-request-wider-admin-menu/).

### 5.1.0 (2023.06.04)

* **[ADDED] Disable Components >> Disable Block-Based Widgets Settings Screen**. Restores the classic widgets settings screen when using a classic (non-block) theme. Props to [@ruralinfo](https://profiles.wordpress.org/ruralinfo/) and [@dvaer](https://profiles.wordpress.org/dvaer/) for [suggesting this](https://wordpress.org/support/topic/feature-request-disable-gutenberg-for-widget-page/).
* **[FIXED] UTILITIES >> SMTP Email Delivery**: fixed an issue where 'from' email is using WP default wordpress@site.com instead of the email defined in module settings. Props to [@scarlywebs](https://wordpress.org/support/users/scarlywebs/) for [reporting it](https://wordpress.org/support/topic/smtp-from-not-working/) and the continued help in testing.
* **[ENHANCED] UTILITIES >> SMTP Email Delivery**: added option to force the usage of the FROM name/email defined in module settings. [Suggested](https://wordpress.org/support/topic/smtp-from-not-working/#post-16762588) by [@scarlywebs](https://wordpress.org/support/users/scarlywebs/).
* **[FIXED]** Custom, right-side footer text now only shows on the plugin's main settings page.

### 5.0.2.4 (2023.06.01)

* **[FIXED] Utilities >> SMTP Email Delivery**: fixed an issue with encoding / decoding of stored password that prevented proper functioning of this module. **Please re-enter your password and save changes**.
* **[FIXED] Utilities >> Password Protection**: fixed an issue with encoding / decoding of stored password that prevented proper functioning of this module. **Please re-enter your password and save changes**.

### 5.0.2.3 (2023.05.25)

* **[FIXED] Log In | Log Out >> Change Login URL**: URLs that start with the custom login slug no longer redirects to the login page. Props to [@netzzjd](https://profiles.wordpress.org/netzzjd/) for [reporting it](https://wordpress.org/support/topic/change-login-url-redirects/).

### 5.0.2.2 (2023.05.24)

* **[FIXED] Log In | Log Out >> Change Login URL**: URLs for lost password flow, i.e. password reset flow, are now accessible when this module is enabled. It will no longer redirect to the not_found (404) page. Props to [@scarlywebs](https://wordpress.org/support/users/scarlywebs/) for [reporting it](https://wordpress.org/support/topic/password-reset-url-link/) and help with testing all the way.

### 5.0.2 (2023.05.09)

* **[FIXED] Utilities >> View Admin as Role**: is now only accessible / usable for administrators.
* **[ENHANCE] Admin Interface >> Admin Menu Organizer**: improved description and UI for better clarity.
* **[POLISH] General code polish** to resolve several PHP warnings.

### 5.0.1 (2023.04.29)

* **[FIXED] WordPress Newsboard link in footer** showing up on all wp-admin pages. Now will only show up on the plugin's main page.

### 5.0.0 (2023.04.29)

* **[ADDED] Content Management >> Content Order**. Enable custom ordering of various content types. Useful for displaying them in the desired order in wp-admin and on the frontend. e.g. projects, services, FAQs, team members, etc.
* **[FIXED] Utilities >> Password Protection**: Fix PHP Warning error. Props to [@cvladan](https://github.com/cvladan) for [reporting it](https://wordpress.org/support/topic/minor-php-warning/).
* **[CHANGED] Content Management >> Page and Post Duplication** module has been renamed to "Content Duplication".
* **[ADDED] Translate link** on plugin page's header and in the .org plugin description page. Please [consider helping to translate](https://translate.wordpress.org/projects/wp-plugins/admin-site-enhancements/) the plugin description (a.k.a. README). There are about 100 strings/sentences in it. This will help expand the reach of Admin and Site Enhancements into people who read/speak your language. Special props to [Angelika Reisiger
](https://profiles.wordpress.org/la-geek/), General Translation Editor for Deutsch (German) #de_DE, for tackling translation of the plugin description into [German](https://translate.wordpress.org/locale/de/default/wp-plugins/admin-site-enhancements/) and [German (formal)](https://translate.wordpress.org/locale/de/formal/wp-plugins/admin-site-enhancements/).
* **[ADDED] Link to [WordPress Newsboard](https://bowo.io/asenha-wpn-dsc)** in plugin page's footer. This is another thing I created back in 2014 and is still working to aggregate the latest news, articles, tutorials, podcasts and videos from 100+ WordPress-centric sources.

### 4.9.3 (2023.04.22)

* **[FIXED] Disable Components >> Disable REST API**: fix for error when trying to save edits in Gutenberg editor when Disable REST API module is turned on. Props to [@alexgraphicd](https://profiles.wordpress.org/alexgraphicd/) for [reporting it](https://wordpress.org/support/topic/cant-save-edits-to-posts-or-pages-when-rest-api-is-disabled/).

### 4.9.2 (2023.04.22)

* **[FIXED] Disable Components >> Disable Comments**: fix for certain scenarios where comment form is still shown despite commenting being disabled on the post type. Props to [@crazyserb](https://profiles.wordpress.org/crazyserb/) for [reporting it](https://wordpress.org/support/topic/disable-comments-functionality-doesnt-work-either/), providng temporary admin access, as well as screenshots to help with troubleshooting!

### 4.9.1 (2023.04.19)

* **[ENHANCEMENT] Admin Interface >> Hide Admin Notices**. LearnDash pages was showing up notices below header. This fix will now move them into the hidden, toggleable notices panel.

### 4.9.0 (2023.04.16)

* **[ENHANCEMENT] Content Management >> External Permalinks**. The rel="noopener noreferrer nofollow" attribute will now be added to external permalinks for enhanced security and SEO benefits. 
* **[ADDED] Content Management >> Open All External Links in New Tab**. Force all links to external sites to open in new browser tab via target="\_blank" attribute. The rel="noopener noreferrer nofollow" attribute will also be added for enhanced security and SEO benefits.

### 4.8.3 (2023.04.15)

* **[FIXED] Content Management >> Content Duplication**: fixed isses when duplicating pages built with Oxygen and Bricks builder. May also solve similar issues with other page builders. Please try this on your page builder installation and report in the forum if you're still experiencing issues.

### 4.8.2 (2023.04.03)

* **[FIXED] Admin Interface >> Admin Menu Organizer**: fix for some menu items missing / being hidden in the menu item sortables. Props to [@chrisplaneta](https://profiles.wordpress.org/chrisplaneta/) for [reporting](https://wordpress.org/support/topic/full-of-useful-features-works-without-problems/#post-16620272).

### 4.8.1 (2023.04.03)

* **[FIXED] Admin Interface >> Hide Admin Notices**: now hides notices on some plugins' pages where an extra div exist above the notice divs.
* **[FIXED] Log In | Log Out >> Change Login URL**: fix an issue where sometimes successful login would redirect to /not_found/ URL.
* **[ENHANCEMENT] Content Management >> Media Replacement**: added browser cache busting via jQuery to ensure the new image is shown on the media/attachment edit page after performing replacement. Elsewhere on wp-admin and on the front end, a hard reload is still needed to flush out browser cache for the old image.

### 4.8.0 (2023.04.02)

* **[ADDED] Utilities >> Multiple User Roles**: Enable assignment of multiple roles during user account creation and editing. This maybe useful for working with roles not defined in WordPress core, e.g. from e-commerce or LMS plugins.


### 4.7.4 (2023.03.05)

* **[ADDED] Content Management >> Enhance List Tables >> Show ID in Action Rows**: on the list tables for pages, all post types, all taxonomies, media, users and comments. Props to [@cvladan](https://github.com/cvladan) for the [feature suggestion](https://github.com/qriouslad/admin-site-enhancements/issues/2).

### 4.7.3 (2023.03.03)

* **[FIXED] Optimizations >> Image Upload Control**: "Unexpected response" error in the media uploader when uploading non-JPG files.

### 4.7.2 (2023.02.25)

* **[FIXED] Disable Components >> Disable Smaller Components >> Disable Emojis** now properly disables emojis in admin pages.

### 4.7.1 (2023.02.24)

* **[CHANGED] Utilities >> Maintenance Mode**. When maintenance mode is enabled, an admin bar icon is shown as an indicator.
* **[CHANGED] Utilities >> Password Protection**. Change background color of admin bar status icon from green to red, to better indicate that the site is (currently) inaccessible to the general public.

### 4.7.0 (2023.02.24)

* **[ADDED] Utilities >> Maintenance Mode**. Show a customizable maintenance page on the frontend while performing a brief maintenance to your site. Logged-in administrators can still view the site as usual.
* **[CHANGED] Disable Components >> Disable Smaller Components >> Disable Dashicons CSS and JS** now excludes the login page. This ensures the login page CSS styles is correctly loaded.
* **[CHANGED] Utilities >> SMTP Email Delivery**. Slight improvement to copy/description for improved clarity.

### 4.6.0 (2023.02.22)

* **[ADDED] Utilities >> SMTP Email Delivery**. Use external SMTP service to ensure notification and transactional emails from your site are being delivered to inboxes.

### 4.5.0 (2023.02.17)

* **[ADDED] Admin Interface >> Clean Up Admin Bar >> Remove the Help tab and drawer**.
* **[ADDED] Disable Components >> Disable Smaller Components**. Prevent smaller components from running or loading. Make the site more secure and load slightly faster. This includes disabling the generator &lt;meta&gt; tag, the Windows Live Writer (WLW) manifest &lt;link&gt; tag, the Really Simple Discovery (RSD) &lt;link&gt; tag and the WordPress shortlink &lt;link&gt; tag in &lt;head&gt;, as well as disabling dashicons CSS and JS files for site visitors, and emoji support for pages, posts and custom post types.

### 4.4.0 (2023.02.05)

* **[ADDED] Custom Code >> Custom Body Class**. Add custom &lt;body&gt; class(es) on the singular view of some or all public post types. Compatible with classes already added using [Custom Body Class plugin](https://wordpress.org/plugins/wp-custom-body-class).

### 4.3.1 (2023.02.05)

* **[CHANGED] Content Management >> Media Replace** option is no longer shown on the grid view of the media library. It will only show up on the attachment edit page which can be reached from both the list view via "Edit or Replace Media" link and the grid view media frame's "Edit more details" link.

### 4.3.0 (2023.01.30)

* **[ADDED] Optimizations >> Image Upload Control**. Resize newly uploaded, large images to a smaller dimension and delete originally uploaded files. BMPs and non-transparent PNGs will be converted to JPGs and resized.
* **[CHANGED] Revisions Control** is now under the Optimizations category.
* **[CHANGED] View Admin as Role** is now under the Utilities category.
* **[CHANGED] Improve title of features** to be shorter and more consistent across categories.

### 4.2.2 (2023.01.24)

* **[FIXED] Admin Interface >> Disable Dashboard Widgets**. Fixed a fatal error issue when there's a widget with priority 'high'. Props to [@samirhp](https://profiles.wordpress.org/samirhp/) for [reporting it](https://wordpress.org/support/topic/error-with-new-update-6/).

### 4.2.1 (2023.01.23)

* **[FIXED] Admin Interface >> Disable Dashboard Widgets**. Fixed missing dashboard widgets list when first trying to activate the feature. Also fixes PHP fatal error when trying to view the dashboard when the feature is activated under such scenario. Props to [@samirhp](https://profiles.wordpress.org/samirhp/) for [reporting it](https://wordpress.org/support/topic/error-with-new-update-6/).

### 4.2.0 (2023.01.23)

* **[ADDED] Admin Interface >> Disable Dashboard Widgets**. Clean up and speed up the dashboard by completely disabling some or all widgets. Disabled widgets won't load any assets nor show up under Screen Options.

### 4.1.0 (2023.01.16)

* **[ADDED] Utilities >> Enable Password Protection**. Password-protect the entire site to hide the content from public view and search engine bots / crawlers. Logged-in administrators can still access normally.

### 4.0.1 (2023.01.12)

* **[FIXED] Content Management >> Enable SVG Upload**: Fixed a bug where uploaded, non-SVG media files does not have metadata generated when Enable SVG Upload is enabled.

### 4.0.0 (2023.01.04)

* **[ADDED] Disable Components >> Disable All Updates**. Completely disable core, theme and plugin updates and auto-updates. Will also disable update checks, notices and emails.

### 3.9.2 (2023.01.03)

* **[FIXED] Custom Code >> Manage robots.txt**. Fixed ["Undefined variable" issue](https://wordpress.org/support/topic/undefine-variable-field_option_value/) reported by [kwbrayton](https://profiles.wordpress.org/kwbrayton/). Also make this feature work on scenarios where an actual robots.txt file exists, not just the virtual one created by default, by WordPress. In such case, the robots.txt file will be renamed to robots_txt_backup_{timestamp}.txt when this feature is enabled. Vice versa, when the feature is disabled, the backup file will be renamed back to robots.txt, so it will be in use again as it were.

### 3.9.1 (2022.12.29)

* **[FIXED] Content Management >> Enable External Permalinks**. Fixed an issue where default WordPress permalink for a post loads white, empty screen when no external permalink has been set for the post.

### 3.9.0 (2022.12.29)

* **[ADDED] Content Management >> Enable External Permalinks**. Enable pages, posts and/or custom post types to have permalinks that point to external URLs. Compatible with links added using [Page Links To](https://wordpress.org/plugins/page-links-to/).

### 3.8.0 (2022.12.27)

* **[ADDED] Optimizations >> Enable Heartbeat Control**. Modify the interval of the WordPress heartbeat API or disable it on admin pages, post creation/edit screens and/or the frontend. This will help reduce CPU load on the server.

### 3.7.0 (2022.12.25)

* **[ADDED] Content Management >> Enable Revisions Control**. Prevent bloating the database by limiting the number of revisions to keep for some or all post types supporting revisions.

### 3.6.1 (2022.12.22)

* **[CHANGED] Custom Code >> Manage robots.txt**. Fixed an issue where code editor was not rendered properly upon clicking the Custom Code tab.

### 3.6.0 (2022.12.22)

* **[CHANGED] Added "Log In | Log Out" and "Custom Code" categories**. Recategorizes relevant features under these new categories.
* **[ADDED] Log In | Log Out >> Enable Last Login Column**. Log when users on the site last logged in and display the date and time in the users list table.

### 3.5.0 (2022.12.19)

* **[ADDED] Utilities >> Manage robots.txt**. Easily edit and validate your robots.txt content.

### 3.4.0 (2022.12.16)

* **[ADDED] Utilities >> Enable Log In/Out Menu**. Enable log in, log out and dynamic log in/out menu item for addition to any menu. Depending on the user's logged-in status, the menu item will show up, disappear or change.

### 3.3.0 (2022.12.12)

* **[ADDED] Utilities >> Insert &lt;head&gt;, &lt;body&gt; and &lt;footer&gt; Code**. Easily insert &lt;meta&gt;, &lt;link&gt;, &lt;script&gt; and &lt;style&gt; tags, Google Analytics, Tag Manager, AdSense, Ads Conversion and Optimize code, Facebook, TikTok and Twitter pixels, etc.
* **[CHANGED] Utilities >> Manage ads.txt and app-ads.txt** is now a single settings field.

### 3.2.0 (2022.12.12)

* **[ADDED] Utilities >> Manage ads.txt and app-ads.txt**: Easily edit and validate your ads.txt and app-ads.txt content. Please backup existing ads.txt and app-ads.txt content and remove those files before copying the original content into the ads.txt and app-ads.txt manager in the Utilities tab. If no ads.txt / app-ads.txt files exist in the root directory of your WordPress installation, you can immediately add content for both files.

### 3.1.0 (2022.12.11)

* **[ADDED] Content Management >> Enable Auto-Publishing of Posts with Missed Schedule**: Trigger publishing of scheduled posts of all types marked with "missed schedule", anytime the site is visited. Uses Transients API to reduce load to the DB on busy sites. Will only query the DB once every 15 minutes (at most).

### 3.0.6 (2022.12.08)

* **[CHANGED] Admin Interface >> Admin Menu Organizer**: Enqueue jQuery UI widget.min.js for WP version less than 5.6.0. This ensures the feature works for those WP versions.

### 3.0.5 (2022.12.08)

* **[CHANGED] Admin Interface >> Admin Menu Organizer**: Enqueue the minified version of jQuery UI scripts, as older versions of WP do not have the unminified version.

### 3.0.4 (2022.12.07)

* **[CHANGED] Admin Interface >> Admin Menu Organizer**: Substantially lower priorities of actions that handles rendering of custom menu order, custom menu title and hiding of menu items. This is so that menu items added late by active plugins and theme are handled properly.

### 3.0.3 (2022.12.07)

* **[CHANGED] Admin Interface >> Admin Menu Organizer**: Make sure menu item sortables reflect custom menu order saved in options, especially when this feature is re-enabled. Remove all HTMl tags and content inside them from menu item titles in the sortables.

### 3.0.2 (2022.12.07)

* **[CHANGED] Hide stubborn notices** appearing inside the admin page header (via CSS).

### 3.0.1 (2022.12.01)

* **[CHANGED] Admin Interface >> Admin Menu Organizer**: Make sure newer menu items added by newly installed plugins or activated theme are showing up towards the end of the admin menu and the menu item sortables. Comments and updates counters are now hidden. Sortables for menu separators have been faded out to make actual menu items stand out more.
* **[CHANGED] Disable Components >> Disable Comments**: Ensure trackbacks metabox is also hidden on edit screens of post types where commenting is disabled.

### 3.0.0 (2022.11.30)

* **[ADDED] Disable Components >> Disable Feeds**: Disable all RSS, Atom and RDF feeds. This includes feeds for posts, categories, tags, comments, authors and search. Also removes traces of feed URLs from &lt;head&gt;.


### 2.9.0 (2022.11.30)

* **[ADDED] Disable Components >> Disable REST API**: Disable REST API access for non-authenticated users and remove URL traces from \<head\>, HTTP headers and WP RSD endpoint.

### 2.8.3 (2022.11.29)

* **[CHANGED] Admin Interface >> Admin Menu Organizer**: Fix for missing Show All toggle in certain scenarios.

### 2.8.2 (2022.11.29)

* **[CHANGED] Admin Interface >> Admin Menu Organizer**: Allow customizing menu item title, for menu items added by plugins or the active theme, i.e. not from WordPress core.

### 2.8.1 (2022.11.28)

* **[CHANGED] Admin Interface >> Admin Menu Organizer**: Fixed the issue when menu items are no longer shown upon saving. This happened when Admin Menu Organizer was enabled and directly saved without making any changes to the menu order first. 

### 2.8.0 (2022.11.28)

* **[ADDED] Disable Components >> Disable Gutenberg**: Disable the Gutenberg block editor for some or all applicable post types. Optionally disable frontend block styles / CSS files for the selected post types.

### 2.7.0 (2022.11.27)

* **[ADDED] Disable Components >> Disable Comments**: Disable comments for some or all public post types. When disabled, existing comments will also be hidden on the frontend.
* **[CHANGED] Security >> Limit Login Attempts**: Improved styling of empty datatable, i.e. when there is no failed login attempts logged.
* **[CHANGED] Settings tab position** is now saved to browser cookie, so it persists upon saving changes or revisiting it from elsewhere in wp-admin.
* **[CHANGED] Some code refactoring** to make logical separation and categorization of features clearer. CodeMirror and DataTables assets loading are also moved

### 2.6.0 (2022.11.19)

* **[ADDED] Content Management >> Enable SVG Upload**: Allow some or all user roles to upload SVG files, which will then be sanitized to keep things secure.

### 2.5.0 (2022.11.18)

* **[ADDED] Security >> Limit Login Attempts**: Prevent brute force attacks by limiting the number of failed login attempts allowed per IP address.
* **[CHANGED] Security >> Custom Login URL** feature has been made compatible with Limit Login Attempts feature.
* **[CHANGED] Security >> Change Login URL** now works with the interim login modal window, the one that pops up when user is logged out in the background.
* **[CHANGED] Security >> Change Login URL** adds another process to ensure user is redirected to the dashboard after successful login. It was redirecting to the /not_found/ (404) page in rare occasions as [reported by @vdrover](https://wordpress.org/support/topic/change-login-url-redirects-to-not-found/).
* **[CHANGED] Utilities >> Redirect After Login** will correctly override default login redirection by Change Login URL.
* **[CHANGED] Improve code comments throughout**.

### 2.4.0 (2022.11.10)

* **[ADDED] Utilities >> Enable Custom Frontend CSS**: Add custom CSS on all frontend pages for all user roles.

### 2.3.0 (2022.11.09)

* **[ADDED] Utilities >> Enable Custom Admin CSS**: Add custom CSS on all admin pages for all user roles.

### 2.2.0 (2022.11.09)

* **[ADDED] Security >> Disable XML-RPC**: Protect your site from brute force, DOS and DDOS attacks via XML-RPC. Also disables trackbacks and pingbacks.
* **[ADDED] Expand/collapse toggle** for feature settings that takes up longer vertical space, e.g. Admin Menu Customizer.
* **[CHANGED] Refactor code around plugin settings page**. Now uses separate classes for sections and fields registration, for sanitization of field values and for rendering the fields on the admin page.

### 2.1.0 (2022.11.08)

* **[ADDED] Security >> Obfuscate Author Slugs**: Obfuscate publicly exposed author page URLs that shows the user slugs / usernames, e.g. _sitename.com/author/username1/_ into _sitename.com/author/a6r5b8ytu9gp34bv/_, and output 404 errors for the original URLs. Also obfuscates in _/wp-json/wp/v2/users/_ REST API endpoint. Props to [pull request](https://github.com/qriouslad/admin-site-enhancements/pull/1) from [Wahyu Arief @wahyuief](https://github.com/wahyuief) and [functions](https://plugins.trac.wordpress.org/browser/smart-user-slug-hider/tags/4.0.2/inc/class-smart-user-slug-hider.php) from [Smart User Slug Hider
](https://wordpress.org/plugins/smart-user-slug-hider/).

### 2.0.0 (2022.11.06)

* **[ADDED] Admin Interface >> Admin Menu Organizer**: Customize the order of the admin menu and optionally hide some items.

### 1.9.0 (2022.11.03)

* **[ADDED] Admin Interface >> Hide or Modify Elements**: Easily simplify or customize various admin UI elements, starting with the admin bar.
* **[CHANGED] Content Management >> Enhance List Tables**: this combines previously separate features related to list tables for various post types.

### 1.8.0 (2022.11.03)

* **[ADDED] Admin Interface >> View Admin as Role**: View admin pages and the site (logged-in) as one of the non-administrator user roles.

### 1.7.0 (2022.10.31)

* **[ADDED] Utilities >> Redirect 404 to Homepage**: Perform 301 (permanent) redirect to the homepage for all 404 (not found) pages.

### 1.6.0 (2022.10.31)

* **[ADDED] Utilities >> Redirect After Logout**: Set custom redirect URL for all or some user roles after logout.

### 1.5.0 (2022.10.30)

* **[ADDED] Utilities >> Redirect After Login**: Set custom redirect URL for all or some user roles after login.

### 1.4.0 (2022.10.30)

* **[ADDED] Security >> Change Login URL**: allow for setting a custom login URL to improve site security.

### 1.3.0 (2022.10.29)

* **[ADDED] Admin Interface >> Hide Admin Bar**: Hide it on the front end for all or some user roles.


### 1.2.0 (2022.10.28)

* **[ADDED] Admin Interface >> Hide Admin Notices**: Clean up admin pages by moving notices into a separate panel easily accessible via the admin bar.

### 1.1.0 (2022.10.22)

* **[ADDED] Content Management >> Enable Media Replacement**: Enable easy replacement of any type of media file with a new one while retaining the existing media ID and file name.

### 1.0.0 (2022.10.17)

* Initial stable release. 